package dbc.r15.sample.b4xxntju;

public class TelWorkAreaWrapperU {
	private final int[] TEL_BUFFER = {0, 100};
	private final int[] TEL_TELLER_ID = {0, 9};
	private final int[] TEL_BRANCH_ID = {9, 9};
	private final int[] TEL_AMOUNT = {18, 5};	// This is signed packed data
	private final int[] TEL_FILLER = {23, 77}; 
	// Variable to hold the binary data in the container 
	 
	private byte[] telData;
	
	 /* Set the binary data of container */
	public void setByteArray(byte[] data) { telData = data;}
	 
	/* Get the binary data of the container */
	public byte[] getByteArray() {return telData;}
	 
	public void setTellerId(String newValue) {setNewValue(newValue, TEL_TELLER_ID[0], TEL_TELLER_ID[1]);
	}
	public String getTellerId() {return new String(telData, TEL_TELLER_ID[0], TEL_TELLER_ID[1]);
	}
	public void setBranchId(String newValue) {setNewValue(newValue, TEL_BRANCH_ID[0], TEL_BRANCH_ID[1]);
	}
	public String getBranchId() {return new String(telData, TEL_BRANCH_ID[0], TEL_BRANCH_ID[1]);
	}
	public void setAmount(String newValue) {setNewValue(newValue, TEL_AMOUNT[0], TEL_AMOUNT[1]);
	}
	public String getAmount() {return new String(telData, TEL_AMOUNT[0], TEL_AMOUNT[1]);
	}
	/* public byte[] getAmByteArray(){
	 *	byte[] b = toByteArray(telData, TEL_AMOUNT[0], TEL_AMOUNT[1]);
	 *}
	 */
	public byte[] getAmtByteArray(){
	String s;
	s = new String(telData, TEL_AMOUNT[0], TEL_AMOUNT[1]);
	return s.getBytes();
	}
	 
	/* Inserts a value into the main byte[] and pads with spaces if necessary.
	 * Note: values will be left justified
	 */
	private void setNewValue(String newValue, int index, int length) {
		/* 1. create a new byte array to hold the string called tData for temporary data
		 * 2. copy the new tData byte array to the cData byte array one byte at a time
		 * 3. pad the cData with spaces up to the length passed in on the call 
		 */
		byte tData[] = newValue.getBytes();		// .step 1.
		int tDatalen = tData.length;
		int cDatalen = telData.length;
		int i = 0;
		while ( i < length && index < cDatalen)
		{
			if ( i < tDatalen )
				telData[index++] = tData[i];
			else
				telData[index++] = 0x40;			
			i++;
		}
	}

}


