package dbc.r15.sample.b4xxntjr;

public class AQlineWrapper {
	private final int[] QLINE_A_BUFFER = {0, 132};
	private final int[] QLINE_A1 = {0, 8};
	private final int[] QLINE_A2 = {8, 4};
	private final int[] QLINE_A3 = {12, 7};
	private final int[] QLINE_A4 = {19, 9};
	private final int[] QLINE_A5 = {28, 10};
	private final int[] QLINE_A6 = {38, 9};
	private final int[] FILLER1 = {47, 1};
	private final int[] QLINE_A7 = {48, 9};
	private final int[] FILLER2 = {57, 1};
	private final int[] QLINE_A8 = {58, 6};
	private final int[] QLINE_A9 = {64, 9};
	private final int[] QLINE_A10 = {73, 6};
	private final int[] QLINE_A11 = {79, 9};
	private final int[] QLINE_A12 = {88, 6};
	private final int[] QLINE_A13 = {94, 7};
	private final int[] QLINE_A14 = {101, 6};
	private final int[] QLINE_A15 = {107, 25};
	private final int[] FILLER3 = {123,9};	// It is 18 in the Cobol program
		// Variable to hold the binary data in the container
		private byte[] qData;
		// Set the binary value of the container
		public void setByteArray(byte[] data) { qData = data;}
		// Get the binary value of the container
		public byte[] getByteArray() {return qData;}
		public String getBuffer() {return new String(qData, 0, qData.length);
		}
		public void setBuffer(String newValue) {setNewBuffer(newValue, QLINE_A_BUFFER[0], QLINE_A_BUFFER[1]);
		}
		public void setQlineA1(String newValue) {setNewValue(newValue, QLINE_A1[0], QLINE_A1[1]);
		}
		public void setQlineA2(String newValue) {setNewValue(newValue, QLINE_A2[0], QLINE_A2[1]);
		}
		public void setQlineA3(String newValue) {setNewValue(newValue, QLINE_A3[0], QLINE_A3[1]);
		}
		public void setQlineA4(String newValue) {setNewValue(newValue, QLINE_A4[0], QLINE_A4[1]);
		}
		public void setQlineA5(String newValue) {setNewValue(newValue, QLINE_A5[0], QLINE_A5[1]);
		}
		public void setQlineA6(String newValue) {setNewValue(newValue, QLINE_A6[0], QLINE_A6[1]);
		}
		public void setQlineA7(String newValue) {setNewValue(newValue, QLINE_A7[0], QLINE_A7[1]);
		}
		public void setQlineA8(String newValue) {setNewValue(newValue, QLINE_A8[0], QLINE_A8[1]);
		}
		public void setQlineA9(String newValue) {setNewValue(newValue, QLINE_A9[0], QLINE_A9[1]);
		}
		public void setQlineA10(String newValue) {setNewValue(newValue, QLINE_A10[0], QLINE_A10[1]);
		}
		public void setQlineA11(String newValue) {setNewValue(newValue, QLINE_A11[0], QLINE_A11[1]);
		}
		public void setQlineA12(String newValue) {setNewValue(newValue, QLINE_A12[0], QLINE_A12[1]);
		}
		public void setQlineA13(String newValue) {setNewValue(newValue, QLINE_A13[0], QLINE_A13[1]);
		}
		public void setQlineA14(String newValue) {setNewValue(newValue, QLINE_A14[0], QLINE_A14[1]);
		}
		public void setQlineA15(String newValue) {setNewValue(newValue, QLINE_A15[0], QLINE_A15[1]);
		}
		private void setNewValue(String newValue, int index, int len) {
	/* 1. create a new byte array to hold the string called tData for temporary data
	 * 2. copy the new tData byte array to the cData byte array one byte at a time Left Justified
	 * 3. pad the cData with spaces up to the length passed in on the call 
	 */
	byte tData[] = newValue.getBytes();		// .step 1.
	int tDatalen = tData.length;
	int qDatalen = qData.length;
	int i = 0;
	while ( i < len && index < qDatalen)
	{
		if ( i < tDatalen )
			qData[index++] = tData[i];
		else
			qData[index++] = 0x40;			
		i++;
	}
}
/* the following method has not being tested or used yet; not needed so far */ 
private void setNewBuffer(String newValue, int index, int len) {	
	/* 1. create a new byte array to hold the string called tData for temporary data
	 * 2. copy the new tData byte array to the cData byte array one byte at a time Right Justified
	 * 3. pad the cData with spaces up to the length passed in on the call 
	 */
	byte qData[] = new byte [len];
	byte tData[] = newValue.getBytes();		// .step 1.
	int tDatalen = tData.length;
	int i = 0;
	while ( index < len)
	{
		if ( i < tDatalen )
			qData[index++] = tData[i++];		
		else
			qData[index++] = 0x40;			
	}
}
}
